import os
from pathlib import Path
from fastapi import APIRouter, HTTPException, Request

from anime.dtos import KillRequest, PlayerOffsetRequest

CWD = Path.cwd()
router = APIRouter()


@router.get("/can-start-watching")
def can_start_watching(request: Request) -> None:
    if not request.app.state.anime_dir:
        raise HTTPException(status_code=400, detail="Anime directory is not set.")


@router.post("/kill")
def kill(input_dto: KillRequest) -> None:
    for name in input_dto.names:
        os.system(f"killall {name}")


@router.post("/start-watching")
def start_watching(request: Request) -> None:
    anime_dir = request.app.state.anime_dir
    if not anime_dir:
        raise HTTPException(status_code=400, detail="Anime directory is not set.")
    os.chdir(anime_dir)
    os.system("awatch")
    os.chdir(CWD)


@router.post("/player/offset")
async def offset(req: PlayerOffsetRequest) -> None:
    direction = "+" if req.forward else "-"
    os.system(f"playerctl position {req.offset}{direction}")


@router.post("/player/play-pause")
async def play_pause() -> None:
    os.system("playerctl play-pause")
